Plugin Manager incorrectly unloads plugins which depends on other plugins

2016-01-29 01:23 AM - Alexander Bruy

Status: Closed
Priority: Normal
Assignee: Borys Jurgiel
Category: Plugin Manager

Affected QGIS version:master
Operating System: all

Pull Request or Patch supplied:
Crashes QGIS or corrupls data:

Regression?: No
Easy fix?: No
Resolution: end of life

Copied to github as #: 22195

Description

There are plugins which depends on other plugins, e.g. Processing provider plugins needs Processing plugin. Plugin Manager incorrectly
handles this case. It seems that plugin unloading does not take in account dependencies between plugins, unload happens in

alphabetical order. As result, during unload Processing plugin unloaded, while other plugins that import its modules still there. This may

cause hangs or crashes depending on user actions.

Processing should be unloaded only after unloading all its provider plugins, or maybe unloaded in the end. This may also affect other

cases when one plugin imports packages from another.

See also discussion at GitHub

History

#1 - 2016-01-29 02:50 AM - Martin Dobias

The real issue is that it currently is impossible to define dependencies for python plugins (either on "usual" python modules or on other python plugins). With

dependencies specified, loading/unloading and installation/removal of plugins would work much better.

#2 - 2017-05-01 01:06 AM - Giovanni Manghi
- Easy fix? set to No

- Regression? set to No
#3 - 2019-03-09 04:09 PM - Giovanni Manghi

- Resolution set to end of life
- Status changed from Open to Closed

End of life notice: QGIS 2.18 LTR

Source:
http://blog.qgis.org/2019/03/09/end-of-life-notice-qgis-2-18-Itr/
https://github.com/qgis/QGIS/pull/2530
http://blog.qgis.org/2019/03/09/end-of-life-notice-qgis-2-18-ltr/

